Index: /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2056)
@@ -1009,5 +1062,6 @@
     PRINT *, ' cv_compress -> '
     debut = .FALSE.
-  END IF !(debut) THEN
+  END IF  !(debut) THEN
+
 
   RETURN
Index: /LMDZ5/branches/testing/libf/phylmd/cvltr.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cvltr.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/cvltr.F90	(revision 2056)
@@ -3,5 +3,6 @@
 !
 SUBROUTINE cvltr(pdtime, da, phi,phi2,d1a,dam, mpIN,epIN, &
-           sigd,sij,clw,elij,epmlmMm,eplaMm,              &
+!!           sigd,sij,clw,elij,epmlmMm,eplaMm,              &   !RL
+           sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,    &     !RL
            pmflxrIN,pmflxsIN,ev,te,wdtrainA,wdtrainM,     &
            paprs,it,tr,upd,dnd,inb,icb,                   &
@@ -47,4 +48,5 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)      :: te 
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij        ! fraction dair de lenv
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd  ! weights of the layers feeding convection
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij       ! contenu en eau condensée spécifique/conc deau condensée massique
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm    ! eau condensee precipitee dans mel masse dair sat
@@ -71,4 +73,5 @@
   REAL,DIMENSION(klon,klev,nbtr)    :: zmfd,zmfa
   REAL,DIMENSION(klon,klev,nbtr)    :: zmfp,zmfu
+  REAL,DIMENSION(klon,nbtr)         :: qfeed     ! tracer concentration feeding convection
 
   REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: zmfd1a
@@ -168,5 +171,5 @@
    scavtrac = 0.
    uscavtrac = 0.
-
+   qfeed(:,it) = 0.              !RL
   DO j=1,klev
    DO i=1,klon
@@ -330,9 +333,23 @@
 ! calcul des tendances liees aux courants satures   j <-> z ; k <-> z'
 ! =========================================
+!
+!RL
+!  Feeding concentrations
   DO j=1,klev
      DO i=1,klon
-        zmfa(i,j,it)=da(i,j)*(tr(i,1,it)-tr(i,j,it))                     ! da
-     END DO
-  END DO
+        qfeed(i,it)=qfeed(i,it)+wght_cvfd(i,j)*tr(i,j,it)
+     END DO
+  END DO
+!RL
+!
+  DO j=1,klev
+     DO i=1,klon
+!RL
+!!        zmfa(i,j,it)=da(i,j)*(tr(i,1,it)-tr(i,j,it))                     ! da
+        zmfa(i,j,it)=da(i,j)*(qfeed(i,it)-tr(i,j,it))                     ! da
+!RL
+     END DO
+  END DO
+!
   DO k=1,klev
      DO j=1,klev
Index: /LMDZ5/branches/testing/libf/phylmd/cvltr_noscav.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cvltr_noscav.F90	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/cvltr_noscav.F90	(revision 2056)
@@ -0,0 +1,197 @@
+!
+! $Id $
+!
+SUBROUTINE cvltr_noscav(it,pdtime,da, phi, mp,wght_cvfd,paprs,pplay,x,upd,dnd,dx)
+  USE dimphy
+  USE infotrac, ONLY : nbtr
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : convection des traceurs / KE
+! Auteurs: M-A Filiberti and J-Y Grandpeix
+!=====================================================================
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+! Entree
+  REAL,INTENT(IN)                           :: pdtime
+  INTEGER, INTENT(IN)                       :: it
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: da
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: mp
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd  ! weights of the layers feeding convection
+  REAL,DIMENSION(klon,klev+1),INTENT(IN)    :: paprs ! pression aux 1/2 couches (bas en haut)
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pplay ! pression pour le milieu de chaque couche
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)      :: x     ! q de traceur (bas en haut) 
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: upd   ! saturated updraft mass flux
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: dnd   ! saturated downdraft mass flux
+
+! Sortie
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT) :: dx ! tendance de traceur  (bas en haut)
+
+! Variables locales     
+! REAL,DIMENSION(klon,klev)       :: zed
+  REAL,DIMENSION(klon,klev,klev)  :: zmd
+  REAL,DIMENSION(klon,klev,klev)  :: za
+  REAL,DIMENSION(klon,klev)       :: zmfd,zmfa
+  REAL,DIMENSION(klon,klev)       :: zmfp,zmfu
+  REAL,DIMENSION(klon,nbtr)       :: qfeed     ! tracer concentration feeding convection
+  REAL,DIMENSION(klon,klev)       :: deltap
+  INTEGER                         :: i,k,j 
+  REAL                            :: pdtimeRG
+  real conserv
+  real smfd
+  real smfu
+  real smfa
+  real smfp
+! =========================================
+! calcul des tendances liees au downdraft
+! =========================================
+!cdir collapse
+  qfeed(:,it) = 0.
+  DO j=1,klev
+  DO i=1,klon
+!   zed(i,j)=0.
+    zmfd(i,j)=0.
+    zmfa(i,j)=0.
+    zmfu(i,j)=0.
+    zmfp(i,j)=0.
+  END DO
+  END DO
+!cdir collapse
+  DO k=1,klev
+  DO j=1,klev
+  DO i=1,klon
+    zmd(i,j,k)=0.
+    za (i,j,k)=0.
+  END DO
+  END DO
+  END DO
+! entrainement
+! DO k=1,klev-1
+!    DO i=1,klon
+!       zed(i,k)=max(0.,mp(i,k)-mp(i,k+1))
+!    END DO
+! END DO
+
+! calcul de la matrice d echange
+! matrice de distribution de la masse entrainee en k
+
+  DO k=1,klev-1
+     DO i=1,klon
+        zmd(i,k,k)=max(0.,mp(i,k)-mp(i,k+1))
+     END DO
+  END DO
+  DO k=2,klev
+     DO j=k-1,1,-1
+        DO i=1,klon
+           if(mp(i,j+1).ne.0) then
+              zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1))
+           ENDif
+        END DO
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev-1
+        DO i=1,klon
+           za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
+        END DO
+     END DO
+  END DO
+!
+! rajout du terme lie a l ascendance induite
+!
+  DO j=2,klev
+     DO i=1,klon
+        za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
+     END DO
+  END DO
+!
+! tendances
+!            
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfd(i,j)=zmfd(i,j)+za(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+!
+! =========================================
+! calcul des tendances liees aux flux satures
+! =========================================
+!RL
+!  Feeding concentrations
+  DO j=1,klev
+     DO i=1,klon
+        qfeed(i,it)=qfeed(i,it)+wght_cvfd(i,j)*x(i,j,it)
+     END DO
+  END DO
+!RL
+!
+  DO j=1,klev
+     DO i=1,klon
+!RL
+!!        zmfa(i,j,it)=da(i,j)*(x(i,1,it)-x(i,j,it))                     ! da
+        zmfa(i,j)=da(i,j)*(qfeed(i,it)-x(i,j,it))                     ! da
+!RL
+     END DO
+  END DO
+!
+!!  print *,'it, qfeed(1,it), x(1,1,it) ', it, qfeed(1,it), x(1,1,it)  !jyg
+!!  print *,'wght_cvfd ', (j, wght_cvfd(1,j), j=1,5)                     !jyg
+!
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfp(i,j)=zmfp(i,j)+phi(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+  DO j=1,klev-1
+     DO i=1,klon
+        zmfu(i,j)=max(0.,upd(i,j+1)+dnd(i,j+1))*(x(i,j+1,it)-x(i,j,it))
+     END DO
+  END DO
+  DO j=2,klev
+     DO i=1,klon
+        zmfu(i,j)=zmfu(i,j)+min(0.,upd(i,j)+dnd(i,j))*(x(i,j,it)-x(i,j-1,it))
+     END DO
+  END DO
+
+! =========================================
+! calcul final des tendances
+! =========================================
+  DO k=1, klev
+     DO i=1, klon
+        deltap(i,k)=paprs(i,k)-paprs(i,k+1)
+     ENDDO
+  ENDDO
+  pdtimeRG=pdtime*RG
+!cdir collapse
+  DO k=1, klev
+     DO i=1, klon
+        dx(i,k,it)=(zmfd(i,k)+zmfu(i,k)       &
+                +zmfa(i,k)+zmfp(i,k))*pdtimeRG/deltap(i,k)
+     ENDDO
+  ENDDO
+
+!! test de conservation du traceur
+      conserv=0.
+      smfd = 0.
+      smfu = 0.
+      smfa = 0.
+      smfp = 0.
+      DO k=1, klev
+        DO i=1, klon
+         conserv=conserv+dx(i,k,it)*   &
+          deltap(i,k)/RG
+         smfd = smfd + zmfd(i,k)*pdtime
+         smfu = smfu + zmfu(i,k)*pdtime
+         smfa = smfa + zmfa(i,k)*pdtime
+         smfp = smfp + zmfp(i,k)*pdtime
+        ENDDO
+      ENDDO
+!!      print *,'it',it,'cvltr_noscav conserv, smfd, smfu, smfa, smfp ',conserv,  &
+!!               smfd, smfu, smfa, smfp
+     
+END SUBROUTINE cvltr_noscav
Index: /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/ener_conserv.F90	(revision 2056)
@@ -20,5 +20,6 @@
 ! From module
 USE phys_local_var_mod, ONLY : d_u_vdf,d_v_vdf,d_t_vdf,d_u_ajs,d_v_ajs,d_t_ajs,d_u_con,d_v_con,d_t_con,d_t_diss
-USE phys_output_var_mod, ONLY : bils_ec,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
+USE phys_local_var_mod, ONLY : d_t_eva,d_t_lsc,d_q_eva,d_q_lsc
+USE phys_output_var_mod, ONLY : bils_ec,bils_ech,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
 
 IMPLICIT none
@@ -41,5 +42,5 @@
 REAL, DIMENSION(klon,klev+1) :: fluxu,fluxv,fluxt
 REAL, DIMENSION(klon,klev+1) :: dddu,dddv,dddt
-REAL, DIMENSION(klon,klev) :: d_u,d_v,d_t,zv,zu
+REAL, DIMENSION(klon,klev) :: d_u,d_v,d_t,zv,zu,d_t_ech
 REAL ZRCPD
 
@@ -131,8 +132,7 @@
 
    do k=1,klev
-      d_t_ec(:,k)=-(dddu(:,k)+dddu(:,k+1)+dddv(:,k)+dddv(:,k+1) &
-   &  +rcpd*(dddt(:,k)+dddt(:,k+1)))/(2.*rcpd*masse(:,k))
+      d_t_ech(:,k)=-(rcpd*(dddt(:,k)+dddt(:,k+1)))/(2.*rcpd*masse(:,k))
+      d_t_ec(:,k)=-(dddu(:,k)+dddu(:,k+1)+dddv(:,k)+dddv(:,k+1))/(2.*rcpd*masse(:,k))+d_t_ech(:,k)
    enddo
-! d_t_ec=0.
 
 ENDIF
@@ -141,4 +141,13 @@
 !  Computation of integrated enthalpie and kinetic energy variation
 !  FH (hourdin@lmd.jussieu.fr), 2013/04/25
+!  bils_ec : energie conservation term
+!  bils_ech : part of this term linked to temperature
+!  bils_tke : change of TKE
+!  bils_diss : dissipation of TKE (when activated)
+!  bils_kinetic : change of kinetic energie of the column
+!  bils_enthalp : change of enthalpie
+!  bils_latent  : change of latent heat. Computed between
+!          after reevaporation (at the beginning of the physics)
+!          and before large scale condensation (fisrtilp)
 !================================================================
 
@@ -157,7 +166,9 @@
      &            -puo(:,k)*puo(:,k)-pvo(:,k)*pvo(:,k))
         bils_enthalp(:)= &
-     &  bils_enthalp(:)+masse(:,k)*(ptn(:,k)-pto(:,k)+d_t_ec(:,k))
+     &  bils_enthalp(:)+masse(:,k)*(ptn(:,k)-pto(:,k)+d_t_ec(:,k)-d_t_eva(:,k)-d_t_lsc(:,k))
+!    &  bils_enthalp(:)+masse(:,k)*(ptn(:,k)-pto(:,k)+d_t_ec(:,k))
         bils_latent(:)=bils_latent(:)+masse(:,k)* &
-     &             (pqn(:,k)-pqo(:,k))
+!    &             (pqn(:,k)-pqo(:,k))
+     &             (pqn(:,k)-pqo(:,k)-d_q_eva(:,k)-d_q_lsc(:,k))
       ENDDO
       bils_ec(:)=rcpd*bils_ec(:)/pdtphys
@@ -167,4 +178,13 @@
       bils_enthalp(:)=rcpd*bils_enthalp(:)/pdtphys
       bils_latent(:)=rlvtt*bils_latent(:)/pdtphys
+
+IF (iflag_ener_conserv>=1) THEN
+      bils_ech(:)=0.
+      DO k=1,klev
+        bils_ech(:)=bils_ech(:)-d_t_ech(:,k)*masse(:,k)
+      ENDDO
+      bils_ech(:)=rcpd*bils_ech(:)/pdtphys
+ENDIF
+
 RETURN
 
Index: /LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 2056)
@@ -29,4 +29,7 @@
   USE netcdf, ONLY : NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR
   USE indice_sol_mod
+  use exner_hyb_m, only: exner_hyb
+  use exner_milieu_m, only: exner_milieu
+  use test_disvert_m, only: test_disvert
 #endif
   IMPLICIT NONE
@@ -74,5 +77,5 @@
   CHARACTER(LEN=80)                        :: x, fmt
   INTEGER                                  :: i, j, l, ji
-  REAL,    DIMENSION(iip1,jjp1,llm)        :: alpha, beta, pk, pls, y
+  REAL,    DIMENSION(iip1,jjp1,llm)        :: pk, pls, y
   REAL,    DIMENSION(ip1jmp1)              :: pks
 
@@ -150,4 +153,5 @@
 
   CALL iniconst()
+  if (pressure_exner) call test_disvert
   CALL inigeom()
 
@@ -253,7 +257,7 @@
   CALL pression(ip1jmp1, ap, bp, psol, p3d)
   if (pressure_exner) then
-    CALL exner_hyb(ip1jmp1, psol, p3d, alpha, beta, pks, pk, y)
+    CALL exner_hyb(ip1jmp1, psol, p3d, pks, pk)
   else
-    CALL exner_milieu(ip1jmp1,psol,p3d,beta,pks,pk,y)
+    CALL exner_milieu(ip1jmp1,psol,p3d, pks,pk)
   endif
   pls(:,:,:)=preff*(pk(:,:,:)/cpp)**(1./kappa)
Index: /LMDZ5/branches/testing/libf/phylmd/fcg_gcssold.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fcg_gcssold.h	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/fcg_gcssold.h	(revision 2056)
@@ -0,0 +1,46 @@
+!
+! $Id: fcg_gcssold.h 2010-08-10 17:02:56Z lahellec $
+!
+      logical :: imp_fcg_gcssold,ts_fcg_gcssold,Tp_fcg_gcssold
+      logical :: Tp_ini_gcssold
+      logical :: xTurb_fcg_gcssold
+
+      common /fcg_gcssold/imp_fcg_gcssold,ts_fcg_gcssold,Tp_fcg_gcssold,        & 
+     & Tp_ini_gcssold,                                                          &
+     & xTurb_fcg_gcssold
+
+!$OMP THREADPRIVATE(/fcg_gcssold/)
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Index: /LMDZ5/branches/testing/libf/phylmd/fcg_racmo.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fcg_racmo.h	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/fcg_racmo.h	(revision 2056)
@@ -0,0 +1,45 @@
+!
+! $Id: fcg_racmo.h 2011-02-16 17:02:56Z cheruy $
+!
+      real   :: a_guide 
+      logical :: ok_invertp 
+      integer :: forc_trb
+      character*31 :: fich_racmo
+
+      common /fcg_racmo/forc_trb,ok_invertp,a_guide,fich_racmo
+
+!$OMP THREADPRIVATE(/fcg_racmo/)
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Index: /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2056)
@@ -13,4 +13,5 @@
   !
   USE dimphy
+  USE microphys_mod ! cloud microphysics (JBM 3/14)
   IMPLICIT none
   !======================================================================
@@ -26,4 +27,5 @@
   include "tracstoke.h"
   include "fisrtilp.h"
+  include "nuage.h" ! JBM (3/14)
   include "iniprint.h"
 
@@ -111,6 +113,10 @@
   REAL zoliq(klon), zcond(klon), zq(klon), zqn(klon), zdelq 
   REAL zoliqp(klon), zoliqi(klon)
-  REAL ztglace, zt(klon)
-  INTEGER nexpo ! exponentiel pour glace/eau
+  REAL zt(klon)
+! JBM (3/14) nexpo is replaced by exposant_glace
+! REAL nexpo ! exponentiel pour glace/eau
+! INTEGER, PARAMETER :: nexpo=6
+  INTEGER exposant_glace_old
+  REAL t_glace_min_old
   REAL zdz(klon),zrho(klon),ztot      , zrhol(klon)
   REAL zchau      ,zfroi      ,zfice(klon),zneb(klon)
@@ -202,11 +208,17 @@
   !  nexpo regle la raideur de la transition eau liquide / eau glace.
   !
-  ztglace = RTT - 15.0
-!AJ<
-  IF (ice_thermo) THEN
-    nexpo = 2
-  ELSE
-    nexpo = 6
+  IF (iflag_t_glace.EQ.0) THEN
+!   ztglace = RTT - 15.0
+    t_glace_min_old = RTT - 15.0
+    !AJ<
+    IF (ice_thermo) THEN
+!     nexpo = 2
+      exposant_glace_old = 2
+    ELSE
+!     nexpo = 6
+      exposant_glace_old = 6
+    ENDIF
   ENDIF
+  
 !!  RLVTT = 2.501e6 ! pas de redefinition des constantes physiques (jyg)
 !!  RLSTT = 2.834e6 ! pas de redefinition des constantes physiques (jyg)
@@ -710,9 +722,11 @@
         endif
      ELSE
+       IF (iflag_t_glace.EQ.0) THEN
          if (iflag_fisrtilp_qsat.lt.1) then
            DO i = 1, klon
-              zfice(i) = 1.0 - (zt(i)-ztglace) / (273.15-ztglace)
+              zfice(i) = 1.0 - (zt(i)-t_glace_min_old) / (273.15-t_glace_min_old)
               zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
-              zfice(i) = zfice(i)**nexpo
+              zfice(i) = zfice(i)**exposant_glace_old
+!             zfice(i) = zfice(i)**nexpo
               zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*zq(i)) &
                        +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*zq(i))
@@ -720,7 +734,8 @@
          else
            DO i=1, klon
-              zfice(i) = 1.0 - (zt(i)-ztglace) / (273.15-ztglace)
+              zfice(i) = 1.0 - (zt(i)-t_glace_min_old) / (273.15-t_glace_min_old)
               zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
-              zfice(i) = zfice(i)**nexpo
+              zfice(i) = zfice(i)**exposant_glace_old
+!             zfice(i) = zfice(i)**nexpo
 !CR: ATTENTION zt different de Tbef: à corriger
               zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i))) &
@@ -729,4 +744,25 @@
          endif
 !         print*,zt(i),zrfl(i),zifl(i),'temp1'
+       ELSE ! of IF (iflag_t_glace.EQ.0)
+         if (iflag_fisrtilp_qsat.lt.1) then
+           DO i = 1, klon
+! JBM: icefrac_lsc is now a function contained in microphys_mod
+              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
+                                     t_glace_max, exposant_glace)
+              zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*zq(i)) &
+                       +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*zq(i))
+           ENDDO
+         else
+           DO i=1, klon
+! JBM: icefrac_lsc is now a function contained in microphys_mod
+              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
+                                     t_glace_max, exposant_glace)
+!CR: ATTENTION zt different de Tbef: à corriger
+              zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i))) &
+                       +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i)))
+           ENDDO
+         endif
+!         print*,zt(i),zrfl(i),zifl(i),'temp1'
+       ENDIF
      ENDIF
 !>AJ
@@ -743,12 +779,23 @@
 !AJ<
      IF (.NOT. ice_thermo) THEN
-     DO i = 1, klon
-        IF (rneb(i,k).GT.0.0) THEN
-           zfice(i) = 1.0 - (zt(i)-ztglace) / (273.13-ztglace)
-           zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
-           zfice(i) = zfice(i)**nexpo
-     !!      zfice(i)=0.
-        ENDIF
-     ENDDO
+       IF (iflag_t_glace.EQ.0) THEN
+         DO i = 1, klon
+            IF (rneb(i,k).GT.0.0) THEN
+               zfice(i) = 1.0 - (zt(i)-t_glace_min_old) / (273.13-t_glace_min_old)
+               zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
+               zfice(i) = zfice(i)**exposant_glace_old
+!              zfice(i) = zfice(i)**nexpo
+         !!      zfice(i)=0.
+            ENDIF
+         ENDDO
+       ELSE ! of IF (iflag_t_glace.EQ.0)
+         DO i = 1, klon
+            IF (rneb(i,k).GT.0.0) THEN
+! JBM: icefrac_lsc is now a function contained in microphys_mod
+              zfice(i) = icefrac_lsc(zt(i), t_glace_min, &
+                                     t_glace_max, exposant_glace)
+            ENDIF
+         ENDDO
+       ENDIF
      ENDIF
      DO i = 1, klon
@@ -895,9 +942,17 @@
         IF (rneb(i,k).GT.0.0.and.zprec_cond(i).gt.0.) THEN
            !AA lessivage nucleation LMD5 dans la couche elle-meme
-           if (t(i,k) .GE. ztglace) THEN
+          IF (iflag_t_glace.EQ.0) THEN
+           if (t(i,k) .GE. t_glace_min_old) THEN
               zalpha_tr = a_tr_sca(3)
            else
               zalpha_tr = a_tr_sca(4)
            endif
+          ELSE ! of IF (iflag_t_glace.EQ.0)
+           if (t(i,k) .GE. t_glace_min) THEN
+              zalpha_tr = a_tr_sca(3)
+           else
+              zalpha_tr = a_tr_sca(4)
+           endif
+          ENDIF
            zfrac_lessi = 1. - EXP(zalpha_tr*zprec_cond(i)/zneb(i))
            pfrac_nucl(i,k)=pfrac_nucl(i,k)*(1.-zneb(i)*zfrac_lessi)
@@ -915,9 +970,17 @@
         DO i = 1, klon
            IF (rneb(i,k).GT.0.0.and.zprec_cond(i).gt.0.) THEN
-              if (t(i,kk) .GE. ztglace) THEN
+             IF (iflag_t_glace.EQ.0) THEN
+              if (t(i,kk) .GE. t_glace_min_old) THEN
                  zalpha_tr = a_tr_sca(1)
               else
                  zalpha_tr = a_tr_sca(2)
               endif
+             ELSE ! of IF (iflag_t_glace.EQ.0)
+              if (t(i,kk) .GE. t_glace_min) THEN
+                 zalpha_tr = a_tr_sca(1)
+              else
+                 zalpha_tr = a_tr_sca(2)
+              endif
+             ENDIF
               zfrac_lessi = 1. - EXP(zalpha_tr*zprec_cond(i)/zneb(i))
               pfrac_impa(i,kk)=pfrac_impa(i,kk)*(1.-zneb(i)*zfrac_lessi)
Index: /LMDZ5/branches/testing/libf/phylmd/iophy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 2056)
@@ -568,4 +568,5 @@
     INCLUDE "temps.h"
     INCLUDE "clesphys.h"
+    INCLUDE "iniprint.h"
 
     INTEGER                          :: iff
@@ -602,6 +603,12 @@
 
 #ifdef CPP_XIOS
+      IF ( var%flag(iff)<=lev_files(iff) ) THEN
         CALL wxios_add_field_to_file(var%name, 2, iff, phys_out_filenames(iff), &
         var%description, var%unit, var%flag(iff), typeecrit)
+        IF (prt_level >= 10) THEN
+          WRITE(lunout,*) 'histdef2d: call wxios_add_field_to_file var%name iff: ', &
+                          trim(var%name),iff
+        ENDIF
+      ENDIF
 #endif
 #ifndef CPP_NO_IOIPSL 
@@ -628,4 +635,5 @@
     END IF
   END SUBROUTINE histdef2d
+
   SUBROUTINE histdef3d (iff,var)
 
@@ -645,4 +653,5 @@
     INCLUDE "temps.h"
     INCLUDE "clesphys.h"
+    INCLUDE "iniprint.h"
 
     INTEGER                          :: iff
@@ -679,6 +688,12 @@
 
 #ifdef CPP_XIOS
+      IF ( var%flag(iff)<=lev_files(iff) ) THEN
         CALL wxios_add_field_to_file(var%name, 3, iff, phys_out_filenames(iff), &
         var%description, var%unit, var%flag(iff), typeecrit)
+        IF (prt_level >= 10) THEN
+          WRITE(lunout,*) 'histdef3d: call wxios_add_field_to_file var%name iff: ', &
+                          trim(var%name),iff
+        ENDIF
+      ENDIF
 #endif
 #ifndef CPP_NO_IOIPSL 
@@ -868,5 +883,5 @@
                                  nid_files
 #ifdef CPP_XIOS
-  USE wxios, only: wxios_write_2D
+  USE xios, only: xios_send_field
 #endif
 
@@ -881,5 +896,7 @@
       
     INTEGER :: iff, iff_beg, iff_end
-      
+    LOGICAL, SAVE  :: firstx
+!$OMP THREADPRIVATE(firstx)
+
     REAL,DIMENSION(klon_mpi) :: buffer_omp
     INTEGER, allocatable, DIMENSION(:) :: index2d
@@ -889,6 +906,7 @@
     REAL, ALLOCATABLE, DIMENSION(:) :: fieldok
 
-    IF (prt_level >= 10) WRITE(lunout,*)'Begin histwrite2d_phy ',trim(var%name)
-
+    IF (prt_level >= 10) THEN
+      WRITE(lunout,*)'Begin histwrite2d_phy for ',trim(var%name)
+    ENDIF
 ! ug RUSTINE POUR LES STD LEVS.....
       IF (PRESENT(STD_iff)) THEN
@@ -925,7 +943,20 @@
 
 ! La boucle sur les fichiers:
+      firstx=.true.
       DO iff=iff_beg, iff_end
             IF (var%flag(iff) <= lev_files(iff) .AND. clef_files(iff)) THEN 
-    
+
+#ifdef CPP_XIOS
+               IF (firstx) THEN
+                  if (prt_level >= 10) then
+                     write(lunout,*)'Dans iophy histwrite2D,iff,var%name ',&
+                                    iff,trim(var%name)                       
+                     write(lunout,*)"histwrite2d_phy:.NOT.clef_stations(iff)and iff==iff_beg, call xios_send_field"
+                  endif
+                  CALL xios_send_field(var%name, Field2d)
+                  firstx=.false.
+               ENDIF
+#endif
+
                   IF(.NOT.clef_stations(iff)) THEN
                         ALLOCATE(index2d(iim*jj_nb))
@@ -934,12 +965,12 @@
                         CALL histwrite(nid_files(iff),var%name,itau_iophy,Field2d,iim*jj_nb,index2d)
 #endif
-#ifdef CPP_XIOS
-                        IF (iff == iff_beg) THEN
-                          if (prt_level >= 10) then
-                            write(lunout,*)"histwrite2d_phy: .NOT.clef_stations(iff) and iff==iff_beg, call wxios_write_2D"
-                          endif
-                          CALL wxios_write_2D(var%name, Field2d)
-                        ENDIF
-#endif
+!#ifdef CPP_XIOS
+!                        IF (iff == iff_beg) THEN
+!                          if (prt_level >= 10) then
+!                            write(lunout,*)"histwrite2d_phy: .NOT.clef_stations(iff) and iff==iff_beg, call xios_send_field"
+!                          endif
+!                          CALL xios_send_field(var%name, Field2d)
+!                        ENDIF
+!#endif
                   ELSE 
                         ALLOCATE(fieldok(npstn))
@@ -988,5 +1019,5 @@
                                  nid_files
 #ifdef CPP_XIOS
-  USE wxios, only: wxios_write_3D
+  USE xios, only: xios_send_field
 #endif
 
@@ -1001,8 +1032,9 @@
       
     INTEGER :: iff, iff_beg, iff_end
-
+    LOGICAL, SAVE  :: firstx
+!$OMP THREADPRIVATE(firstx)
     REAL,DIMENSION(klon_mpi,SIZE(field,2)) :: buffer_omp
     REAL :: Field3d(iim,jj_nb,SIZE(field,2))
-    INTEGER :: ip, n, nlev
+    INTEGER :: ip, n, nlev, nlevx
     INTEGER, ALLOCATABLE, DIMENSION(:) :: index3d
     REAL,ALLOCATABLE, DIMENSION(:,:) :: fieldok
@@ -1033,5 +1065,9 @@
     IF (SIZE(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
     nlev=SIZE(field,2)
-
+    if (nlev.eq.klev+1) then
+        nlevx=klev
+    else
+        nlevx=nlev
+    endif
 
     CALL Gather_omp(field,buffer_omp)
@@ -1041,6 +1077,20 @@
 
 ! BOUCLE SUR LES FICHIERS
+     firstx=.true.
      DO iff=iff_beg, iff_end
             IF (var%flag(iff) <= lev_files(iff) .AND. clef_files(iff)) THEN
+#ifdef CPP_XIOS
+              IF (firstx) THEN
+                if (prt_level >= 10) then
+                  write(lunout,*)'Dans iophy, histwrite3D iff nlev klev firstx', &
+                                  iff,nlev,klev, firstx                       
+                  write(lunout,*)'histwrite3d_phy: call xios_send_field for ', &
+                                  trim(var%name), ' with iim jjm nlevx = ', &
+                                  iim,jj_nb,nlevx
+                endif
+                CALL xios_send_field(var%name, Field3d(:,:,1:nlevx))
+                            firstx=.false.
+              ENDIF
+#endif
                 IF (.NOT.clef_stations(iff)) THEN
                         ALLOCATE(index3d(iim*jj_nb*nlev))
@@ -1051,10 +1101,10 @@
 #endif
 
-#ifdef CPP_XIOS
-                        IF (iff == 1) THEN
-                              CALL wxios_write_3D(var%name, Field3d(:,:,1:klev))
-                        ENDIF
-#endif
-                        
+!#ifdef CPP_XIOS
+!                        IF (iff == 1) THEN
+!                              CALL xios_send_field(var%name, Field3d(:,:,1:klev))
+!                        ENDIF
+!#endif
+!                        
                 ELSE 
                         nlev=size(field,2)
@@ -1099,5 +1149,5 @@
                                 is_sequential, klon_mpi_begin, klon_mpi_end, &
                                 jj_nb, klon_mpi
-  USE wxios, only: wxios_write_2D
+  USE xios, only: xios_send_field
 
 
@@ -1134,5 +1184,5 @@
 
 
-        CALL wxios_write_2D(field_name, Field2d)
+        CALL xios_send_field(field_name, Field2d)
 
     ELSE 
@@ -1170,5 +1220,5 @@
                                 is_sequential, klon_mpi_begin, klon_mpi_end, &
                                 jj_nb, klon_mpi
-  USE wxios, only: wxios_write_3D
+  USE xios, only: xios_send_field
 
 
@@ -1204,5 +1254,5 @@
         ALLOCATE(index3d(iim*jj_nb*nlev))
         ALLOCATE(fieldok(iim*jj_nb,nlev))
-        CALL wxios_write_3D(field_name, Field3d(:,:,1:klev))
+        CALL xios_send_field(field_name, Field3d(:,:,1:nlev))
                         
     ELSE 
